<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>GODDeSS: PropertyToolsManager Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.1 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
      <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>PropertyToolsManager Class Reference</h1><!-- doxytag: class="PropertyToolsManager" -->
<p>a class making the processing of the properties etc. much easier.  
</p>

<p><a href="classPropertyToolsManager-members.html">List of all members.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPropertyToolsManager.html#aa08e84f363498e972921962e79331038">PropertyToolsManager</a> (std::vector&lt; G4double &gt; energyRangeVector)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPropertyToolsManager.html#a5a4232e3d04290936d9ce74006b432cd">~PropertyToolsManager</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPropertyToolsManager.html#ae685b492be121828ed11a40d72167def">AddElementsFromTable</a> (G4Material *&amp;material, <a class="el" href="classProperties.html#a6ede445f9f1982bf1c96c816e2c34f6d">Properties::tabular</a> elementTable)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPropertyToolsManager.html#a7a578a87633eab4abc5ee71f3f11f301">checkIfMaterialAlreadyExists</a> (G4String materialName, G4Material *&amp;material)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">G4MaterialPropertyVector *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPropertyToolsManager.html#a0fe530c71091f1a960d3fd3864ca334d">GetPropertyDistribution</a> (G4double propertyValue)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">G4MaterialPropertyVector *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPropertyToolsManager.html#aad2b37c45aa2198b4ef72bfddf7b61bc">GetPropertyDistribution</a> (<a class="el" href="classProperties.html">Properties</a> properties, G4String propertyKey)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">G4bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPropertyToolsManager.html#a856a37e359ba71b28d829530375d99e9">isConstantProperty</a> (G4MaterialPropertyVector *propertyVector)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">G4MaterialPropertyVector *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPropertyToolsManager.html#a9b0afce45e83ff05562cfdc0022ed170">tabular_to_G4MaterialPropertyVector</a> (<a class="el" href="classProperties.html#a6ede445f9f1982bf1c96c816e2c34f6d">Properties::tabular</a> tabular)</td></tr>
<tr><td colspan="2"><h2>Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">G4bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPropertyToolsManager.html#a52b34e3f06b73b4070cab2ae8100da53">properySpectrumEqual</a> (G4MaterialPropertyVector *propertyVector1, G4MaterialPropertyVector *propertyVector2)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">G4bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPropertyToolsManager.html#aa0e56aa28c09a3c0a9b785921446b069">sameMaterials</a> (G4Material *material1, G4Material *material2)</td></tr>
</table>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aa08e84f363498e972921962e79331038"></a><!-- doxytag: member="PropertyToolsManager::PropertyToolsManager" ref="aa08e84f363498e972921962e79331038" args="(std::vector&lt; G4double &gt; energyRangeVector)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">PropertyToolsManager::PropertyToolsManager </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; G4double &gt;&nbsp;</td>
          <td class="paramname"> <em>energyRangeVector</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Constructor:</p>
<ul>
<li>sets the energy range on which the property should be defined </li>
</ul>

</div>
</div>
<a class="anchor" id="a5a4232e3d04290936d9ce74006b432cd"></a><!-- doxytag: member="PropertyToolsManager::~PropertyToolsManager" ref="a5a4232e3d04290936d9ce74006b432cd" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual PropertyToolsManager::~PropertyToolsManager </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Destructor (empty) </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="ae685b492be121828ed11a40d72167def"></a><!-- doxytag: member="PropertyToolsManager::AddElementsFromTable" ref="ae685b492be121828ed11a40d72167def" args="(G4Material *&amp;material, Properties::tabular elementTable)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PropertyToolsManager::AddElementsFromTable </td>
          <td>(</td>
          <td class="paramtype">G4Material *&amp;&nbsp;</td>
          <td class="paramname"> <em>material</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classProperties.html#a6ede445f9f1982bf1c96c816e2c34f6d">Properties::tabular</a>&nbsp;</td>
          <td class="paramname"> <em>elementTable</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Function to add the elements (specified in the chemical component data in the material property file) to the material </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>material</em>&nbsp;</td><td>material to which the elements should be added </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>elementTable</em>&nbsp;</td><td>tabular (from <a class="el" href="classProperties.html">Properties</a>) with the chemical component data of the material </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7a578a87633eab4abc5ee71f3f11f301"></a><!-- doxytag: member="PropertyToolsManager::checkIfMaterialAlreadyExists" ref="a7a578a87633eab4abc5ee71f3f11f301" args="(G4String materialName, G4Material *&amp;material)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void PropertyToolsManager::checkIfMaterialAlreadyExists </td>
          <td>(</td>
          <td class="paramtype">G4String&nbsp;</td>
          <td class="paramname"> <em>materialName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">G4Material *&amp;&nbsp;</td>
          <td class="paramname"> <em>material</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Function to check if a <b> newly generated </b> material had already been registered to GEANT:</p>
<ul>
<li>checks if a material with <em>materialName</em> already exists<ul>
<li><b> if not </b>, set the name of <em>material</em> to <em>materialName</em> </li>
<li><b> else </b>, check if <em>material</em> and the existing material with <em>materialName</em> are the same (<a class="el" href="classPropertyToolsManager.html#aa0e56aa28c09a3c0a9b785921446b069">sameMaterials()</a>)<ul>
<li><b> if so </b>, remove the <b> &gt; last &lt; </b> material that was registered to GEANT</li>
<li><b> else </b>, set the name of <em>material</em> to an extended <em>materialName</em> </li>
</ul>
</li>
</ul>
</li>
</ul>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>materialName</em>&nbsp;</td><td>material name that should be checked </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>material</em>&nbsp;</td><td>material that should be checked </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0fe530c71091f1a960d3fd3864ca334d"></a><!-- doxytag: member="PropertyToolsManager::GetPropertyDistribution" ref="a0fe530c71091f1a960d3fd3864ca334d" args="(G4double propertyValue)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">G4MaterialPropertyVector * PropertyToolsManager::GetPropertyDistribution </td>
          <td>(</td>
          <td class="paramtype">G4double&nbsp;</td>
          <td class="paramname"> <em>propertyValue</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Function to transform a constant property into an energy dependent distribution.</p>
<dl class="return"><dt><b>Returns:</b></dt><dd>G4MaterialPropertyVector with the energy dependent spectrum of the given property </dd></dl>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>propertyValue</em>&nbsp;</td><td>constant vakue that should be transformed into a distribution </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aad2b37c45aa2198b4ef72bfddf7b61bc"></a><!-- doxytag: member="PropertyToolsManager::GetPropertyDistribution" ref="aad2b37c45aa2198b4ef72bfddf7b61bc" args="(Properties properties, G4String propertyKey)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">G4MaterialPropertyVector * PropertyToolsManager::GetPropertyDistribution </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classProperties.html">Properties</a>&nbsp;</td>
          <td class="paramname"> <em>properties</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">G4String&nbsp;</td>
          <td class="paramname"> <em>propertyKey</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Function to extract the spectrum from the <a class="el" href="classProperties.html">Properties</a> of the material property file:</p>
<ul>
<li>if <a class="el" href="classProperties.html">Properties</a> contains a spectrum of the desired property, <a class="el" href="classPropertyToolsManager.html#a9b0afce45e83ff05562cfdc0022ed170">tabular_to_G4MaterialPropertyVector()</a> is used</li>
<li>if <a class="el" href="classProperties.html">Properties</a> contains a constant of the desired property, it is changed to a spectrum</li>
</ul>
<dl class="return"><dt><b>Returns:</b></dt><dd>G4MaterialPropertyVector with the energy dependent spectrum of the desired property </dd></dl>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>properties</em>&nbsp;</td><td>tabular (from <a class="el" href="classProperties.html">Properties</a>) of the desired property </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>propertyKey</em>&nbsp;</td><td>key to identify the desired property </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a856a37e359ba71b28d829530375d99e9"></a><!-- doxytag: member="PropertyToolsManager::isConstantProperty" ref="a856a37e359ba71b28d829530375d99e9" args="(G4MaterialPropertyVector *propertyVector)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">G4bool PropertyToolsManager::isConstantProperty </td>
          <td>(</td>
          <td class="paramtype">G4MaterialPropertyVector *&nbsp;</td>
          <td class="paramname"> <em>propertyVector</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Function to check, if a spectrum is constant. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>propertyVector</em>&nbsp;</td><td>spectrum to be checked if it is constant </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a52b34e3f06b73b4070cab2ae8100da53"></a><!-- doxytag: member="PropertyToolsManager::properySpectrumEqual" ref="a52b34e3f06b73b4070cab2ae8100da53" args="(G4MaterialPropertyVector *propertyVector1, G4MaterialPropertyVector *propertyVector2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">G4bool PropertyToolsManager::properySpectrumEqual </td>
          <td>(</td>
          <td class="paramtype">G4MaterialPropertyVector *&nbsp;</td>
          <td class="paramname"> <em>propertyVector1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">G4MaterialPropertyVector *&nbsp;</td>
          <td class="paramname"> <em>propertyVector2</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Function to compair two spectra, if they are exactly the same. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>propertyVector1</em>&nbsp;</td><td>1. spectrum to be compaired </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>propertyVector2</em>&nbsp;</td><td>2. spectrum to be compaired </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa0e56aa28c09a3c0a9b785921446b069"></a><!-- doxytag: member="PropertyToolsManager::sameMaterials" ref="aa0e56aa28c09a3c0a9b785921446b069" args="(G4Material *material1, G4Material *material2)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">G4bool PropertyToolsManager::sameMaterials </td>
          <td>(</td>
          <td class="paramtype">G4Material *&nbsp;</td>
          <td class="paramname"> <em>material1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">G4Material *&nbsp;</td>
          <td class="paramname"> <em>material2</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Function to compair two material, if they are exactly the same. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>material1</em>&nbsp;</td><td>1. material to be compaired </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>material2</em>&nbsp;</td><td>2. material to be compaired </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a9b0afce45e83ff05562cfdc0022ed170"></a><!-- doxytag: member="PropertyToolsManager::tabular_to_G4MaterialPropertyVector" ref="a9b0afce45e83ff05562cfdc0022ed170" args="(Properties::tabular tabular)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">G4MaterialPropertyVector * PropertyToolsManager::tabular_to_G4MaterialPropertyVector </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classProperties.html#a6ede445f9f1982bf1c96c816e2c34f6d">Properties::tabular</a>&nbsp;</td>
          <td class="paramname"> <em>tabular</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Function to extract the spectrum from a tabular (from <a class="el" href="classProperties.html">Properties</a>):</p>
<ul>
<li>if necessary, calculates the energy from the wave length</li>
<li>fills the spectrum into a G4MaterialPropertyVector</li>
</ul>
<dl class="return"><dt><b>Returns:</b></dt><dd>G4MaterialPropertyVector with the energy dependent spectrum of the desired property </dd></dl>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>tabular</em>&nbsp;</td><td>tabular (from <a class="el" href="classProperties.html">Properties</a>) of the desired property </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Typedefs</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr size="1"/><address style="text-align: right;"><small>Generated on 13 Feb 2014 for GODDeSS by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
